alias -l mklagbar {
  if ($toolbar(lag)) toolbar -d lag
  if ($toolbar(lagsep)) toolbar -d lagsep
  var %w = 65, %h = 16, %ph = 9
  var %y = $calc((%h - %ph) / 2)
  window -phf @lag 0 0 100 20
  drawrect -rf @lag $rgb(face) 1 0 0 %w %h
  var %lag = $calc(%lag.mylag. [ $+ [ $cid ] ] / 10)
  if (%lag > 100) %lag = 100
  if (%lag.lag) && (%lag.ram) {
    drawtext -ro @lag @rgb(text) "Courier New" 8 0 -2 LAG
    drawtext -ro @lag @rgb(text) "Courier New" 8 0 7 RAM
    draw.progress @lag 23 0 40 7 %lag
    draw.progress @lag 23 9 40 7 $ramuse
  }
  if (%lag.lag) && (!%lag.ram) {
    drawtext -ro @lag @rgb(text) "Courier New" 10 0 1 LAG
    draw.progress @lag 25 2 40 12 %lag
  }
  if (!%lag.lag) && (%lag.ram) {
    drawtext -ro @lag @rgb(text) "Courier New" 10 0 1 RAM
    draw.progress @lag 25 2 40 12 $ramuse
  }
  if (!%lag.lag) && (!%lag.ram) {
    drawtext -ro @lag @rgb(text) "Wingdings 3" 10 3 1 
    toolbar -i 1 lag Lag @lag 0 0 16 16
  }

  else toolbar -i 1 lag Lag @lag 0 0 %w %h
  toolbar -o lag @lag
  toolbar -is 2 lagsep 

  .timerLagbar -mi 0 250 lagbar.update
}

alias -l draw.progress {
  var %3 = $4, %4 = $5, %l = $6
  window -phf @tmp 0 0 %3 $calc(%4 + 2)
  drawrect -rf @tmp $rgb(face) 1 0 0 %3 %4
  drawline -r @tmp $rgb(0,0,0) 1 1 0 $calc(%3 - 1) 0
  drawline -r @tmp $rgb(0,0,0) 1 1 $calc(%4 - 1) $calc(%3 - 1) $calc(%4 - 1)
  drawline -r @tmp $rgb(0,0,0) 1 0 1 0 $calc(%4 - 1)
  drawline -r @tmp $rgb(0,0,0) 1 $calc(%3 - 1) 1 $calc(%3 - 1) $calc(%4 - 1)
  var %x = $round($calc( %l / 100 * $calc(%3 - 2)),0)
  var %i = $calc(%4 - 2), %p = $calc(2 * $pi / %i), %r, %r2
  while (%i) { %r = $calc(175 + $cos($calc(%p * %i)) * 50 ) | %r2 = %r - 50 | drawline -r @tmp $rgb(%r2,%r,%r2) 1 1 %i $calc(%x + 1) %i | dec %i }
  var %i = $calc(%4 - 2), %p = $calc(2 * $pi / %i), %r, %r2
  while (%i) { %r = $calc(230 + $cos($calc(%p * %i)) * 25 ) | %r2 = %r - 0 | drawline -r @tmp $rgb(%r2,%r,%r2) 1 $calc(%x + 1) %i $calc(%3 - 1) %i | dec %i }
  drawcopy @tmp 0 0 %3 %4 $1-3
  window -c @tmp
}

alias -l ramuse {
  ; Thanks to [T]-BoNes for ProcInfo.dll
  ; http://mircscripts.org/comments.php?cid=1185

  var %f = $scriptdir $+ ProcInfo.dll

  var %a = $dll(%f,GetRam,memory)
  var %u = %a - $dll(%f,GetRam,memoryavail)
  return $round($calc(%u / %a * 100),0) $+ $iif($1,% ( $+ $kbs(%u) / $kbs(%a) $+ ))
}

alias -l lagbar.update {
  if (!$toolbar(lag)) .timerLagbar off
  else {
    var %lag = $calc(%lag.mylag. [ $+ [ $cid ] ] / 10)
    if (%lag > 100) %lag = 100

    if (%lag.lag) && (%lag.ram) {
      draw.progress @lag 23 0 40 7 %lag
      draw.progress @lag 23 9 40 7 $ramuse
    }
    if (%lag.lag) && (!%lag.ram) {
      draw.progress @lag 25 2 40 12 %lag
    }
    if (!%lag.lag) && (%lag.ram) {
      draw.progress @lag 25 2 40 12 $ramuse
    }
    if (!%lag.lag) && (!%lag.ram) {
      ;
    }

    else toolbar -p lag @lag 0 0 65 16
    toolbar -t lag "Lag: $calc(%lag.mylag. [ $+ [ $cid ] ] / 1000) $+ s, Ram: $ramuse(1) "
  }
}

alais -l kbs return $bytes($calc( $1 * 1024 )).suf
alias -l lagcheck !ping lag. $+ $cid $+ . $+ $ticks

menu @lag {
  $style($iif(%lag.lag,1,0)) Lagbar:set %lag.lag $iif(%lag.lag,0,1) | mklagbar
  $style($iif(%lag.ram,1,0)) Rambar:set %lag.ram $iif(%lag.ram,0,1) | mklagbar
  -
  $style($iif(%lag.run,1,0)) Load at startup:set %lag.run $iif(%lag.run,0,1)
  -
  Close bar:toolbar -d lag | toolbar -d lagsep
}
menu Status {
  -
  $iif(!$toolbar(lag),Open lagbar):mklagbar
  $iif($toolbar(lag),Lagbar)
  .$style($iif(%lag.lag,1,0)) Lagbar:set %lag.lag $iif(%lag.lag,0,1) | mklagbar
  .$style($iif(%lag.ram,1,0)) Rambar:set %lag.ram $iif(%lag.ram,0,1) | mklagbar
  .-
  .$style($iif(%lag.run,1,0)) Load at startup:set %lag.run $iif(%lag.run,0,1)
  .-
  .Close bar:toolbar -d lag | toolbar -d lagsep
  -
}

on *:start:if (%lag.run) mklagbar
on *:connect:.timerLag. $+ $cid 0 3 lagcheck
on ^*:pong:if ($gettok($2,1,46) == lag) { set %lag.mylag. [ $+ [ $cid ] ] $calc($ticks - $gettok($2,3,46)) | halt }
on *:load:set %lag.run 1 | set %lag.lag 1 | set %lag.ram 1 | mklagbar
on *:unload:.timerLag.* off | .timerLagbar off | toolbar -d lag | toolbar -d lagsep | unset %lag.*